﻿class Track extends MovieClip
{	
	var mSegments:Array;
	
	public function Track()
	{
		mSegments = new Array();
	}
	
	public function AddSegment(aStart:Vect, anEnd:Vect)
	{
		var s:TrackSegment = TrackSegment(attachMovie("TrackSegment","plutt",getNextHighestDepth()));
		s.Set(aStart,anEnd);
		mSegments.push(s);
	}
	
	public function SetXML(xmlCont:XML, copy:Boolean, index:Number)
	{
		var points:Array = xmlCont.firstChild.childNodes;
		trace(xmlCont.toString());
		
		for ( var i = 0; i + 1< points.length; i= i+2)
		{
			var p = points[i].childNodes;
			var from:Vect = new Vect(parseInt(p[0].firstChild), parseInt(p[1].firstChild));
			
			p = points[i+1].childNodes;
			
			var to:Vect = new Vect(parseInt(p[0].firstChild), parseInt(p[1].firstChild));
			AddSegment(from,to);
		}
		
		if(copy)
		{
			var alternate:Track = Track(_root.attachMovie("Track", "alternate" + index, _root.getNextHighestDepth()));
			alternate.SetXML(xmlCont, false);
			alternate._x = this._x + this._width;
			alternate._y = this._y;
			Accessor.RegisterAlternateTrack(alternate);
		}
	}
	
	public function onLoad()
	{
	}
	
	public function intersect(xpos:Number,ypos:Number, radius:Number)
	{
		for(var i=0;i<mSegments.length;i++)
		{
			var p:TrackSegment = TrackSegment(mSegments[i]);
			var scaledNormal = p.intersect(xpos, ypos, radius);
			if ( scaledNormal != undefined )
			{
				return scaledNormal;
			}
		}
		return undefined;
	}
}