﻿class Vect
{
	var x:Number;
	var y:Number;
	
	public function Vect(x:Number, y:Number)
	{
		this.x = x;
		this.y = y;
	}
	
	public function addVector(v:Vect)
	{
		x += v.x;
		y += v.y;
	}
	
	public function normalize()
	{
		var len:Number;
		len = GetLength();
		x*=1/len;
		y*=1/len;
	}
	
	public function GetLength()
	{
		return Math.sqrt(x*x+y*y);
	}
	
	public function multiply(multiplier:Number)
	{
		x *= multiplier;
		y *= multiplier;
	}
	
	public function dot(v:Vect)
	{
		return x*v.x+y*v.y;
	}
	
	public function CreateLeftRotated()
	{
		return new Vect(-y,x);
	}
	
	public function CreateRightRotated()
	{
		return new Vect(y,-x);
	}
	
	public function subtract(v:Vect)
	{
		x-=v.x;
		y-=v.y;
	}
}