﻿class Accessor extends MovieClip
{
	static var players:Array = new Array();
	static var tracks:Array = new Array();
	static var alternateTracks:Array = new Array();
	static var currentTrackIndex:Number = 0;
	
	public static function Init()
	{
		SetCurrentTrackIndex(0);
	}
	
	public static function GetPlayer(playerIndex:Number):PlayerAvatar
	{
		return players[playerIndex];
	}
	
	public static function RegisterPlayer(player:PlayerAvatar)
	{
		players.push(player);
		player.SetPlayerNumber(players.length);
	}
	
	public static function PrintDebug(str:String)
	{
		_root["DebugText"].text = str;
	}
	
	public static function GetTrack(trackIndex:Number):Track
	{
		return tracks[trackIndex];
	}
	
	public static function GetNumTracks():Number
	{
		return tracks.length;
	}
	
	public static function RegisterTrack(track:Track)
	{
		tracks.push(track);
	}
	
	public static function RegisterAlternateTrack(track:Track, index:Number)
	{
		if(index == 0)
		{
			alternateTracks.splice(0, 0, Track);
		}
		alternateTracks.push(track);
	}
	
	public static function GetAlternateTrack(trackIndex:Number):Track
	{
		return alternateTracks[trackIndex];
	}
	
	public static function GetCurrentTrack()
	{
		return GetTrack(currentTrackIndex);
	}
	
	public static function GetCurrentAlternateTrack()
	{
		return GetAlternateTrack(currentTrackIndex);
	}
	
	public static function SetCurrentTrackIndex(track:Number)
	{
		for(var i:Number = 0; i < GetNumTracks(); i++)
		{
			GetTrack(i)._alpha = 30;
			GetAlternateTrack(i)._alpha = 30;
			trace("inne");
		}
		trace("ute");
		currentTrackIndex = track;
		GetTrack(currentTrackIndex)._alpha = 100;
		GetAlternateTrack(currentTrackIndex)._alpha = 100;
	}
	
	public static function GetCurrentTrackIndex():Number
	{
		return currentTrackIndex;
	}
}