﻿
class Controller extends MovieClip
{
	var moveLimit:Number;
	var wasToggleDown;
	var wasToggleDown2;
	public function onLoad()
	{
		Key.addListener(this);
		moveLimit = Stage.width * 0.7;
		wasToggleDown = false;
		wasToggleDown2 = false;
	} 
	
	public function onMouseDown()
	{
		//Accessor.GetPlayer(0).onForwardDown();
	}
	
	public function onMouseUp()
	{
		//Accessor.GetPlayer(0).onForwardUp();
	}
	
	public function onKeyDown()
	{
		Accessor.PrintDebug(String(Key.getCode()));
		switch (Key.getAscii()) {
    	case 119 :  //w
        	Accessor.GetPlayer(0).onForwardDown();
        	break;
    	case 105 :
        	Accessor.GetPlayer(1).onForwardDown();
        	break;
		case 115 : //s
			if(!wasToggleDown)
			{
        		TogglePlane();
				wasToggleDown = true;
			}
        	break;
		case 107 : 
			if(!wasToggleDown)
			{
        		TogglePlane();
				wasToggleDown2 = true;
			}
        	break;
		}
		
	}
	
	public function onKeyUp()
	{
		switch (Key.getAscii()) {
    	case 119 :  //w
        	Accessor.GetPlayer(0).onForwardUp();
        	break;
    	case 105 :
        	Accessor.GetPlayer(1).onForwardUp();
        	break;
		case 115 : //s
        	wasToggleDown = false;
        	break;
		case 107 : 
			wasToggleDown = false;
        	break;
		}
		
	}
	
	
	public function onEnterFrame()
	{
		var maxX = 0;
		for(var i:Number = 0; i < 2; i++)
		{
			Accessor.GetPlayer(i).Update();
			if(Accessor.GetPlayer(i)._x > maxX)
			{
				maxX = Accessor.GetPlayer(i)._x;
			}
		}
		var moveLength = maxX - moveLimit;
		
		if(moveLength > 0)
		{
			for(var i:Number = 0; i < 2; i++)
			{
				Accessor.GetPlayer(i)._x -= moveLength;
			}
			
			for(var i:Number = 0; i < Accessor.GetNumTracks(); i++)
			{
				Accessor.GetTrack(i)._x -= moveLength;
				if(Accessor.GetTrack(i)._x + Accessor.GetTrack(i)._width < 0)
				{
					Accessor.GetTrack(i)._x = Accessor.GetAlternateTrack(i)._x + Accessor.GetAlternateTrack(i)._width;
				}
				
				Accessor.GetAlternateTrack(i)._x -= moveLength;
				if(Accessor.GetAlternateTrack(i)._x + Accessor.GetAlternateTrack(i)._width < 0)
				{
					Accessor.GetAlternateTrack(i)._x = Accessor.GetTrack(i)._x + Accessor.GetTrack(i)._width;
				}
			}
			
			_root["nearHills1"]._x -= moveLength;
			if(_root["nearHills1"]._x + _root["nearHills1"]._width < 0)
			{
				_root["nearHills1"]._x = _root["nearHills2"]._x + _root["nearHills2"]._width;
			}
				
			_root["nearHills2"]._x -= moveLength;
			if(_root["nearHills2"]._x + _root["nearHills2"]._width < 0)
			{
				_root["nearHills2"]._x = _root["nearHills1"]._x + _root["nearHills1"]._width;
			}
			
			_root["farHills1"]._x -= moveLength * 0.5;
			if(_root["farHills1"]._x + _root["farHills1"]._width < 0)
			{
				_root["farHills1"]._x = _root["farHills2"]._x + _root["farHills2"]._width;
			}
				
			_root["farHills2"]._x -= moveLength * 0.5;
			if(_root["farHills2"]._x + _root["farHills2"]._width < 0)
			{
				_root["farHills2"]._x = _root["farHills1"]._x + _root["farHills1"]._width;
			}
			
			_root["clouds1"]._x -= moveLength * 0.25;
			if(_root["clouds1"]._x + _root["clouds1"]._width < 0)
			{
				_root["clouds1"]._x = _root["clouds2"]._x + _root["clouds2"]._width;
			}
				
			_root["clouds2"]._x -= moveLength * 0.25;
			if(_root["clouds2"]._x + _root["clouds2"]._width < 0)
			{
				_root["clouds2"]._x = _root["clouds1"]._x + _root["clouds1"]._width;
			}
		}
			
		for(var i:Number = 0; i < Accessor.GetNumTracks(); i++)
		{
			Accessor.GetAlternateTrack(i)._alpha = Accessor.GetTrack(i)._alpha;
		}
	}
	
	private function TogglePlane()
	{
		if(Accessor.GetCurrentTrackIndex() == 0)
		{
			Accessor.SetCurrentTrackIndex(1);
		}
		else
		{
			Accessor.SetCurrentTrackIndex(0);
			Accessor.PrintDebug("toggle back");
		}
	}
	
}